//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "AnalogIndEvents.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "_GClass"
#pragma link "AbLED"
#pragma link "AbVMeter"
#pragma resource "*.dfm"
TAnalogIndEventsForm *AnalogIndEventsForm;
//---------------------------------------------------------------------------
__fastcall TAnalogIndEventsForm::TAnalogIndEventsForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TAnalogIndEventsForm::AbVMeter5Limit(TObject *Sender,
      bool Lower, bool Upper)
{
  AbLED1->Checked = Lower;
  AbLED2->Checked = Upper;
}
//---------------------------------------------------------------------------
void __fastcall TAnalogIndEventsForm::AbVMeter5MinMaxChange(
      TObject *Sender)
{
  AnsiString MinStr, MaxStr;
  MaxStr = "Max : "+
           FormatFloat(AbVMeter5->SignalSettings->ValueFormat,AbVMeter5->MinMax->Max) +
           " " + AbVMeter5->SignalSettings->ValueUnit +
           " , " + DateTimeToStr(AbVMeter5->MinMax->MaxDateTime);

  MinStr = "Min : "+
           FormatFloat(AbVMeter5->SignalSettings->ValueFormat,AbVMeter5->MinMax->Min) +
           " " + AbVMeter5->SignalSettings->ValueUnit +
           " , " + DateTimeToStr(AbVMeter5->MinMax->MinDateTime);

  Label12->Caption = MaxStr;
  Label13->Caption = MinStr;
}
//---------------------------------------------------------------------------
void __fastcall TAnalogIndEventsForm::AbVMeter5Overflow(TObject *Sender,
      int PPT)
{
  if ((PPT >= 0) && (PPT <= 1000))
    Label2->Caption = "Value Normal";
  else if ((PPT >= -100) && (PPT <= -1))
    Label2->Caption = "Value to Low";
  else if ((PPT >= 1001) && (PPT <= 1100))
    Label2->Caption = "Value to High";
}
//---------------------------------------------------------------------------
void __fastcall TAnalogIndEventsForm::AbVMeter5SectorChange(
      TObject *Sender, bool Sector1, bool Sector2, bool Sector3,
      bool Enter)
{
   if (Enter) {
      if (Sector1)
        AbLED3->Checked = true;
      else if (Sector2)
        AbLED4->Checked = true;
       else if (Sector3)
        AbLED5->Checked = true;
   } else AbLED6->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TAnalogIndEventsForm::AbVMeter5ValueChange(TObject *Sender)
{
   Label14->Caption = AbVMeter5->ValueStr;
}
//---------------------------------------------------------------------------
void __fastcall TAnalogIndEventsForm::FormCreate(TObject *Sender)
{
   AbVMeter5->ResetMinMax();
   Label14->Caption = AbVMeter5->ValueStr;
   AbLED4->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TAnalogIndEventsForm::Button1Click(TObject *Sender)
{
   AbVMeter5->ResetMinMax();
}
//---------------------------------------------------------------------------
void __fastcall TAnalogIndEventsForm::ScrollBar1Change(TObject *Sender)
{
   AbVMeter5->Digit = ScrollBar1->Position;
}
//---------------------------------------------------------------------------
