//---------------------------------------------------------------------------
#ifndef AnalogIndEventsH
#define AnalogIndEventsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "_GClass.hpp"
#include "AbLED.hpp"
#include "AbVMeter.hpp"
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TAnalogIndEventsForm : public TForm
{
__published:	// Komponenten, die von der IDE verwaltet werden
    TAbVMeter *AbVMeter5;
    TBevel *Bevel1;
    TGroupBox *GroupBox1;
    TLabel *Label12;
    TLabel *Label13;
    TButton *Button1;
    TGroupBox *GroupBox2;
    TAbLED *AbLED3;
    TAbLED *AbLED4;
    TAbLED *AbLED5;
    TAbLED *AbLED6;
    TGroupBox *GroupBox4;
    TLabel *Label2;
    TGroupBox *GroupBox3;
    TLabel *Label14;
    TMemo *Memo1;
    TBitBtn *BitBtn1;
    TScrollBar *ScrollBar1;
    TGroupBox *GroupBox5;
    TAbLED *AbLED1;
    TAbLED *AbLED2;
    void __fastcall AbVMeter5Limit(TObject *Sender, bool Lower,
          bool Upper);
    void __fastcall AbVMeter5MinMaxChange(TObject *Sender);
    void __fastcall AbVMeter5Overflow(TObject *Sender, int PPT);
    void __fastcall AbVMeter5SectorChange(TObject *Sender, bool Sector1,
          bool Sector2, bool Sector3, bool Enter);
    void __fastcall AbVMeter5ValueChange(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall Button1Click(TObject *Sender);
    void __fastcall ScrollBar1Change(TObject *Sender);
private:	// Benutzerdeklarationen
public:		// Benutzerdeklarationen
    __fastcall TAnalogIndEventsForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TAnalogIndEventsForm *AnalogIndEventsForm;
//---------------------------------------------------------------------------
#endif
