//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#include <stdlib.h>
#pragma hdrstop

#include "_AbTrend.h"
#include "_AbPrintTrend.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "_GClass"
#pragma link "AbNumEdit"
#pragma link "AbTrend"
#pragma link "AbVInd"
#pragma resource "*.dfm"
TAbTrendForm *AbTrendForm;
AnsiString ExePath;
int Dummy1,Dummy2,Dummy3,Dummy4,Dummy5,Dummy6,Dummy7,Dummy8;
//---------------------------------------------------------------------------
__fastcall TAbTrendForm::TAbTrendForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::TimeCBClick(TObject *Sender)
{
  if (TimeCB->Checked)
    AbTrend1->Options = AbTrend1->Options << opTime;
  else
    AbTrend1->Options = AbTrend1->Options >> opTime;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::DateCBClick(TObject *Sender)
{
  if (DateCB->Checked)
    AbTrend1->Options = AbTrend1->Options << opDate;
  else
    AbTrend1->Options = AbTrend1->Options >> opDate;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::Ch8LowerLimitCBClick(TObject *Sender)
{
  if (Ch8LowerLimitCB->Checked)
    AbTrend1->Options = AbTrend1->Options << opCh8isLL;
  else
    AbTrend1->Options = AbTrend1->Options >> opCh8isLL;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::Ch7UpperLimitCBClick(TObject *Sender)
{
  if (Ch7UpperLimitCB->Checked)
    AbTrend1->Options = AbTrend1->Options << opCh7isUL;
  else
    AbTrend1->Options = AbTrend1->Options >> opCh7isUL;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::AbsScaleCBClick(TObject *Sender)
{
  if (AbsScaleCB->Checked)
    AbTrend1->Options = AbTrend1->Options << opRightScale;
  else
    AbTrend1->Options = AbTrend1->Options >> opRightScale;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::LeftScaleVisibleCBClick(TObject *Sender)
{
  if (LeftScaleVisibleCB->Checked)
    AbTrend1->Options = AbTrend1->Options << opLeftScale;
  else
    AbTrend1->Options = AbTrend1->Options >> opLeftScale;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::SpinGridStepsValueChanged(TObject *Sender)
{
  AbTrend1->GridYSteps = SpinGridSteps->ValueAsInt;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::SpinLeftScaleValueChanged(TObject *Sender)
{
  AbTrend1->LeftScaleCh = SpinLeftScale->ValueAsInt;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::SpinAbsScaleValueChanged(TObject *Sender)
{
  AbTrend1->AbsScaleCh = SpinAbsScale->ValueAsInt;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::FillChSpinValueChanged(TObject *Sender)
{
  AbTrend1->FillChannelNo = FillChSpin->ValueAsInt;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::FastBtnClick(TObject *Sender)
{
  AbTrend1->RunInterval2(300); // 300 records with interval 2
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::SaveBtnClick(TObject *Sender)
{
  int err;
  err = AbTrend1->SaveToFile(ExePath + "test.trd");
  // err = FileIO error code, ok if 0
  CheckBox1->Checked = false;
  // flow = off
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::LoadBtnClick(TObject *Sender)
{
  int err;
  err = AbTrend1->LoadFromFile(ExePath + "test.trd");
  // err = FileIO error code, ok if 0
  CheckBox1->Checked = false;
  // flow = off
  StartRecCheckbox->Checked = false;
  // StartRecording = false
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::DeleteBtnClick(TObject *Sender)
{
  AbTrend1->ClearRecords();
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::PrintBtnClick(TObject *Sender)
{
 TForm *frm;
 try
 {
   frm = new TAbPrintTrendForm(Application);
   frm->ShowModal();
 }
 __finally
 {
   frm->Free();
 }
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::AbTrend1RecNoChanged(TObject *Sender)
{
  Label11->Caption = IntToStr(AbTrend1->RecordInfo->TotalRecords);
  Label14->Caption = DateTimeToStr(AbTrend1->RecordInfo->FirstRecord);
  Label15->Caption = DateTimeToStr(AbTrend1->RecordInfo->LastRecord);
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::FormDestroy(TObject *Sender)
{
  DelControl(this);
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::StartRecCheckboxClick(TObject *Sender)
{
  AbTrend1->StartRecording = StartRecCheckbox->Checked;
  FastBtn->Enabled = StartRecCheckbox->Checked;
  // only enabled if StartRecording
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::FormCreate(TObject *Sender)
{
  ExePath = ExtractFileDir(ParamStr(0)) + "\\";

  Dummy1 = 0;
  Dummy2 = 0;
  Dummy3 = 225;
  Dummy4 = 675;
  Dummy5 = 458;
  Dummy6 = 10;
  Dummy7 = 0;
  Dummy8 = 0;
  AddControl(this,100);
  // 100ms interval
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::BigJumpFwdBtnClick(TObject *Sender)
{
  AbTrend1->MoveX(AbTrend1->GridXPixel*4);
  CheckBox1->Checked = false;
  // flow = off
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::BigJumpRevBtnClick(TObject *Sender)
{
  AbTrend1->MoveX(-AbTrend1->GridXPixel*4);
  CheckBox1->Checked = false;
  // flow = off
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::CheckBox9Click(TObject *Sender)
{
   AbTrend1->Channel8->Visible = CheckBox9->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::CheckBox8Click(TObject *Sender)
{
   AbTrend1->Channel7->Visible = CheckBox8->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::CheckBox7Click(TObject *Sender)
{
   AbTrend1->Channel6->Visible = CheckBox7->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::CheckBox6Click(TObject *Sender)
{
   AbTrend1->Channel5->Visible = CheckBox6->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::CheckBox5Click(TObject *Sender)
{
   AbTrend1->Channel4->Visible = CheckBox5->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::CheckBox4Click(TObject *Sender)
{
  AbTrend1->Channel3->Visible = CheckBox4->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::CheckBox3Click(TObject *Sender)
{
  AbTrend1->Channel2->Visible = CheckBox3->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::CheckBox2Click(TObject *Sender)
{
  AbTrend1->Channel1->Visible = CheckBox2->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::SpeedButton4Click(TObject *Sender)
{
   AbTrend1->ZoomYOut();
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::SpeedButton2Click(TObject *Sender)
{
   AbTrend1->ZoomYIn();
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::SpeedButton3Click(TObject *Sender)
{
  AbTrend1->SetYDefault();
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::SpeedButton5Click(TObject *Sender)
{
  AbTrend1->MoveY(- 10);
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::SpeedButton1Click(TObject *Sender)
{
  AbTrend1->MoveY(10);
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::JumpFwdBtnClick(TObject *Sender)
{
  AbTrend1->MoveX(AbTrend1->GridXPixel);
  CheckBox1->Checked = false;
  // flow = off
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::JumpRevBtnClick(TObject *Sender)
{
  AbTrend1->MoveX(-AbTrend1->GridXPixel);
  CheckBox1->Checked = false;
  // flow = off
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::AbTrend1NewCursorPos(TObject *Sender)
{
  if (AbTrend1->ValueAtCursor->DataValid)
  {
     AbValueInd1->Value = AbTrend1->ValueAtCursor->ValueCh1;
     AbValueInd2->Value = AbTrend1->ValueAtCursor->ValueCh2;
     AbValueInd3->Value = AbTrend1->ValueAtCursor->ValueCh3;
     AbValueInd4->Value = AbTrend1->ValueAtCursor->ValueCh4;
     AbValueInd5->Value = AbTrend1->ValueAtCursor->ValueCh5;
     AbValueInd6->Value = AbTrend1->ValueAtCursor->ValueCh6;
     AbValueInd7->Value = AbTrend1->ValueAtCursor->ValueCh7;
     AbValueInd8->Value = AbTrend1->ValueAtCursor->ValueCh8;
     Label7->Caption = IntToStr(AbTrend1->ValueAtCursor->RecordNo);
     Label4->Caption = DateTimeToStr(AbTrend1->ValueAtCursor->Time);
  } else {
     AbValueInd1->Value = 0;
     AbValueInd2->Value = 0;
     AbValueInd3->Value = 0;
     AbValueInd4->Value = 0;
     AbValueInd5->Value = 0;
     AbValueInd6->Value = 0;
     AbValueInd7->Value = 0;
     AbValueInd8->Value = 0;
     Label7->Caption = "not Valid";
     Label4->Caption = "-----";
  }
}
//---------------------------------------------------------------------------
void __fastcall TAbTrendForm::CheckBox1Click(TObject *Sender)
{
  AbTrend1->Flow = CheckBox1->Checked;
}
//---------------------------------------------------------------------------


void __fastcall TAbTrendForm::WMFlash(TMessage &Msg)
{
  // used to calc. some values
  if (ComponentState.Contains(csDesigning))
    return;

  Dummy1 = Dummy1+1;
  if (Dummy1 > 100)
  {
    Dummy1 = 0;
    if (AbTrend1->Channel8->Digit == 900)
      AbTrend1->Channel8->Digit = 800;
    else
      AbTrend1->Channel8->Digit = 900;
  }

  Dummy2 = Dummy2 +1 ;
  if (Dummy2 >= 9000)
    Dummy2 = 0;

  Dummy3 = Dummy3 +1 ;
  if (Dummy3 >= 9000)
    Dummy3 = 0;

  Dummy4 = Dummy4 +1 ;
  if (Dummy4 > 9000)
    Dummy4 = 0;

  Dummy5 = Dummy5 +Dummy6 ;
  if (Dummy5 >= 9000)
    Dummy6 = -10;
  else
    if (Dummy5 <= 0)
      Dummy6 = 10;

  AbTrend1->Channel1->Value = 20+sin(Dummy4/100);
  AbTrend1->Channel2->Value = 4+ sin(Dummy3/100);
  AbTrend1->Channel3->Value = sin(Dummy2/100)*3.12;
  AbTrend1->Channel4->Value = 20+sin(Dummy3/100);
  AbTrend1->Channel5->Digit = Dummy1;
  AbTrend1->Channel6->Value = 5+Dummy5/1800;
  AbTrend1->Channel7->Value = 13+random(30)/10;
}
